using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    internal class Program
    {
        
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());

            List<int> Pos = Array.ConvertAll(Console.ReadLine().Split(), int.Parse).ToList();
            Pos.Sort();
            
            int Harry = 0;

            // Levo -> Jug
            // Desno -> Sever

            int NajbliziSaLeveStrane = int.MinValue;
            int NajbliziSaLeveStraneIndex = int.MinValue;
            int NajbliziSaDesneStrane = int.MaxValue;
            int NajbliziSaDesneStraneIndex = int.MaxValue;
            // Samo jednom vidiem ko je najblizi i to
            for (int i = 0; i < Pos.Count; i++)
            {
                int CurrentPos = Pos[i];

                if (CurrentPos < Harry)
                {
                    if (NajbliziSaLeveStrane < CurrentPos)
                    {
                        NajbliziSaLeveStrane = CurrentPos;
                        NajbliziSaLeveStraneIndex = i;
                    } 

                } else
                {
                    
                    if (NajbliziSaDesneStrane > CurrentPos)
                    {
                        NajbliziSaDesneStrane = CurrentPos;
                        NajbliziSaDesneStraneIndex = i;
                    }
                }
            }

            int PucaLevoCooldown = 0;
            int PucaDesnoCooldown = 0;
            
            string Potezi = "";

            bool simulacijaZivi = true;

            int Eliminacije = 0;
            int BrojPoteza = 0;
            while (simulacijaZivi) {
                if (BrojPoteza >= 1_000_000) break;
                BrojPoteza++;

                int LeftDist = Harry - (NajbliziSaLeveStrane + BrojPoteza);
                int RightDist = NajbliziSaDesneStrane - (BrojPoteza - Harry);
                
                bool isInDangerLeft = LeftDist < 2;
                bool isInDangerRight = RightDist < 2;

                PucaLevoCooldown--;
                PucaDesnoCooldown--;

                bool CanShootRight = PucaDesnoCooldown <= 0;
                bool CanShootLeft = PucaLevoCooldown <= 0;

                if (isInDangerLeft)
                {
                    if (CanShootLeft)
                    {
                        Potezi += "1";
                        if (NajbliziSaLeveStrane != int.MinValue) Eliminacije++;
                        NajbliziSaLeveStrane = int.MinValue;
                        PucaLevoCooldown = 2;
                    }
                    else if (isInDangerRight && CanShootRight)
                    {
                        PucaDesnoCooldown = 2;
                        Potezi += "2";
                        if (NajbliziSaDesneStrane != int.MaxValue) Eliminacije++;
                        NajbliziSaDesneStrane = int.MaxValue;
                    }
                    else
                    {
                        Potezi += "3";
                        Harry += 1;
                    }
                }
                else 
                { 
                    if (CanShootRight) {
                        PucaDesnoCooldown = 2;
                        Potezi += "2";
                        if (NajbliziSaDesneStrane != int.MaxValue) Eliminacije++;
                        NajbliziSaDesneStrane = int.MaxValue;
                    } else
                    {
                        Potezi += "1";
                        if (NajbliziSaLeveStrane != int.MinValue) Eliminacije++;
                        NajbliziSaLeveStrane = int.MinValue;
                        PucaLevoCooldown = 2;
                    }
                }

                LeftDist = Harry - (NajbliziSaLeveStrane + BrojPoteza);
                RightDist = NajbliziSaDesneStrane - (BrojPoteza - Harry);

                if (NajbliziSaLeveStrane != int.MinValue)
                {
                    if (LeftDist < 1) break;
                }
                else if (NajbliziSaLeveStraneIndex > 0)
                {
                    NajbliziSaLeveStraneIndex--;
                    NajbliziSaLeveStrane = Pos[NajbliziSaLeveStraneIndex];
                }

                if (NajbliziSaDesneStrane != int.MaxValue)
                {
                    if (RightDist < 1) break;
                } else if (NajbliziSaDesneStraneIndex < N - 1)
                {
                    NajbliziSaDesneStraneIndex++;
                    NajbliziSaDesneStrane = Pos[NajbliziSaDesneStraneIndex];
                }

                if (NajbliziSaLeveStrane == int.MinValue && NajbliziSaDesneStrane == int.MaxValue) break;
            }
            Console.WriteLine(Eliminacije);
            Console.WriteLine(Potezi);
        }
    }
}